

function love.load()
	--[[ball = {
	x = 400,
	y = 300,
	vx = 0,
	vy = 0,
	bild = love.graphics.newImage('ball.png')}  ]]
	ballbild = love.graphics.newImage('ball.png')
	angle = 0

  nKnoten = 20  
  knoten = {}
	for i = 1,nKnoten do
	  knoten[i] = {
	  x = 400+i*5,
	  y = 50+i*5,
		xold = 400+i*5,
		yold = 50+i*5,
	  vx = 0,
	  vy = 0}
	end

  gravity = 2000
  length = 20
	ropeSpeed = 15
	speed = 5
--  federhaerte = 500
  damp = 1--0.999
	love.graphics.setLineWidth(3)
	nIterations = 10
end

function love.update(dt)
	--cursor.x, cursor.y = love.mouse.getPosition()
--	knoten[1].x, knoten[1].y = love.mouse.getPosition()
	-- Advance each node by velocity
	for i = 1,nKnoten do
		local	k = knoten[i]
		k.x, k.xold = (1+damp)*k.x-damp*k.xold, k.x
		k.y, k.yold = (1+damp)*k.y-damp*k.yold, k.y
--		k.y = k.y + gravity*dt
	end
	knoten[1].x = 400
	knoten[1].y = 50
	knoten[nKnoten].y = knoten[nKnoten].y + gravity*dt*dt
	if love.keyboard.isDown("right") then
		knoten[nKnoten].x = knoten[nKnoten].x + speed*dt
	end
	if love.keyboard.isDown("left") then
		knoten[nKnoten].x = knoten[nKnoten].x - speed*dt
	end
	if love.keyboard.isDown("up") then
		length = math.max(0,length-ropeSpeed*dt)
	end
	if love.keyboard.isDown("down") then
		length = length+ropeSpeed*dt
	end

	-- Force rope constraints
	for j = 1,nIterations do
	-- Iterate over inner rope parts, keeping ends at constant positions
		for i = 1,nKnoten-2 do
			dx = knoten[i+1].x-knoten[i].x
			dy = knoten[i+1].y-knoten[i].y
			dist = math.sqrt(dx*dx+dy*dy)
			if dist ~=0 then
				-- Force constraint
				knoten[i+1].x = knoten[i].x+dx/dist*length
				knoten[i+1].y = knoten[i].y+dy/dist*length
			end
		end

		for i = nKnoten-1,2,-1 do
			dx = knoten[i].x-knoten[i+1].x
			dy = knoten[i].y-knoten[i+1].y
			dist = math.sqrt(dx*dx+dy*dy)
			if dist~=0 then
				-- Force constraint
				knoten[i].x = knoten[i+1].x+dx/dist*length
				knoten[i].y = knoten[i+1].y+dy/dist*length
			end
		end
	end
	-- One final sweep, allowing to move the free end
	for i = 1,nKnoten-1 do
		dx = knoten[i+1].x-knoten[i].x
		dy = knoten[i+1].y-knoten[i].y
		dist = math.sqrt(dx*dx+dy*dy)
		if dist ~=0 then
			-- Force constraint
			knoten[i+1].x = knoten[i].x+dx/dist*length
			knoten[i+1].y = knoten[i].y+dy/dist*length
		end
	end
	dy = knoten[nKnoten].y - knoten[nKnoten-1].y
	dx = knoten[nKnoten].x - knoten[nKnoten-1].x
	angle = math.atan2(-dx,dy)
end

function love.draw()
	for i=1,nKnoten-1 do
		love.graphics.line(knoten[i].x,knoten[i].y,knoten[i+1].x,knoten[i+1].y)
	end
	love.graphics.draw(ballbild,knoten[nKnoten].x,knoten[nKnoten].y,angle,1,1,8,4)
end

function love.keypressed(key)
   if key == "escape" then
      love.event.push("quit")
   end
end
